unit etmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, msEstTimer, StdCtrls;

type
  TForm1 = class(TForm)
    msEstTimer1: TmsEstTimer;
    Label1: TLabel;
    ResultLabel: TLabel;
    StartButton: TButton;
    Label3: TLabel;
    Label4: TLabel;
    ElapsedLabel: TLabel;
    EstimatedLabel: TLabel;
    CancelButton: TButton;
    procedure msEstTimer1DisplayElapsedTime(Sender: TObject;
      TheTime: TDateTime);
    procedure msEstTimer1DisplayEstTime(Sender: TObject;
      TheTime: TDateTime);
    procedure msEstTimer1GetCurrentCount(Sender: TObject;
      var Count: Integer);
    procedure msEstTimer1GetTotalCount(Sender: TObject;
      var Count: Integer);
    procedure StartButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private declarations }
    Total: LongInt;
    Current: LongInt;
    Canceled: boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.msEstTimer1DisplayElapsedTime(Sender: TObject;
  TheTime: TDateTime);
begin
  ElapsedLabel.Caption:=FormatDateTime('hh:mm:ss',TheTime);
end;

procedure TForm1.msEstTimer1DisplayEstTime(Sender: TObject;
  TheTime: TDateTime);
begin
  EstimatedLabel.Caption:=FormatDateTime('hh:mm:ss',TheTime);
end;

procedure TForm1.msEstTimer1GetCurrentCount(Sender: TObject;
  var Count: Integer);
begin
  Count:=Current;
end;

procedure TForm1.msEstTimer1GetTotalCount(Sender: TObject;
  var Count: Integer);
begin
  Count:=Total;
end;

procedure TForm1.StartButtonClick(Sender: TObject);
var
  Sum: LongInt;
begin
  ResultLabel.Caption:='Calculating';
  StartButton.Enabled:=false;
  CancelButton.Enabled:=true;
  msEstTimer1.Enabled:=true;
  Current:=1; Total:=5000000; Sum:=0; Canceled:=false;
  while (Current<=Total) and not Canceled do
  begin
    Sum:=Sum+Current;
    Inc(Current);
    Application.ProcessMessages;
  end;
  msEstTimer1.Enabled:=false;
  CancelButton.Enabled:=false;
  StartButton.Enabled:=true;
  if Canceled then
    ResultLabel.Caption:='Operation has been canceled'
  else
    ResultLabel.Caption:='Result is '+IntToStr(Sum);
end;

procedure TForm1.CancelButtonClick(Sender: TObject);
begin
  Canceled:=true;
end;

end.
